'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _timm = require('timm');

var _storyboard = require('storyboard');

var _readSpecs = require('./utils/readSpecs');

var _constants = require('./utils/constants');

var _helpers = require('./utils/helpers');

var _writeSpecs = require('./utils/writeSpecs');

var _writeSpecs2 = _interopRequireDefault(_writeSpecs);

var _shell = require('./utils/shell');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var run = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(deps, opts) {
    var src, ignoreSrc, linkPattern, allSpecs, pkgNames, versions, i, dep, _parseDep, name, version, finalVersion, _ref2, stdout;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            src = opts.src, ignoreSrc = opts.ignoreSrc, linkPattern = opts.link;
            _context.next = 3;
            return (0, _readSpecs.readAllSpecs)(src, ignoreSrc);

          case 3:
            allSpecs = _context.sent;
            pkgNames = Object.keys(allSpecs);

            // Determine correct version for each dep

            versions = {};
            i = 0;

          case 7:
            if (!(i < deps.length)) {
              _context.next = 29;
              break;
            }

            dep = deps[i];
            _parseDep = (0, _helpers.parseDep)(dep), name = _parseDep.name, version = _parseDep.version;
            finalVersion = version;

            if (finalVersion) {
              _context.next = 25;
              break;
            }

            if (!(pkgNames.indexOf(dep) >= 0)) {
              _context.next = 16;
              break;
            }

            finalVersion = '^' + allSpecs[dep].specs.version;
            _context.next = 25;
            break;

          case 16:
            if (!(linkPattern && new RegExp(linkPattern).test(dep))) {
              _context.next = 20;
              break;
            }

            finalVersion = '*';
            _context.next = 25;
            break;

          case 20:
            _context.next = 22;
            return (0, _shell.exec)('npm info ' + dep + ' version', {
              logLevel: 'trace'
            });

          case 22:
            _ref2 = _context.sent;
            stdout = _ref2.stdout;

            finalVersion = '^' + stdout.trim();

          case 25:
            versions[name] = finalVersion;

          case 26:
            i++;
            _context.next = 7;
            break;

          case 29:
            _storyboard.mainStory.info('New versions of these packages:', { attach: versions });

            // Update all package.json files with this version
            pkgNames.forEach(function (pkgName) {
              var _allSpecs$pkgName = allSpecs[pkgName],
                  specPath = _allSpecs$pkgName.specPath,
                  prevSpecs = _allSpecs$pkgName.specs;

              var nextSpecs = prevSpecs;
              deps.forEach(function (dep) {
                var _parseDep2 = (0, _helpers.parseDep)(dep),
                    depName = _parseDep2.name;

                _constants.DEP_TYPES.forEach(function (type) {
                  var depsOfType = nextSpecs[type] || {};
                  if (depsOfType[depName] != null) {
                    nextSpecs = (0, _timm.setIn)(nextSpecs, [type, depName], versions[depName]);
                  }
                });
              });
              if (nextSpecs !== prevSpecs) (0, _writeSpecs2.default)(specPath, nextSpecs);
            });

          case 31:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, undefined);
  }));

  return function run(_x, _x2) {
    return _ref.apply(this, arguments);
  };
}();

exports.default = run;