'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _minimatch = require('minimatch');

var _minimatch2 = _interopRequireDefault(_minimatch);

var _multiRun = require('./utils/multiRun');

var _multiRun2 = _interopRequireDefault(_multiRun);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var run = function run(script, options) {
  return (0, _multiRun2.default)(options, function (specs) {
    var scripts = specs.scripts;

    if (!scripts) return [];
    var scriptNames = Object.keys(scripts).filter(function (o) {
      return (0, _minimatch2.default)(o, script);
    });
    if (!scriptNames.length) return [];
    return scriptNames.map(function (o) {
      return 'yarn run ' + o;
    });
  });
};

exports.default = run;