'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.addVersionLine = undefined;

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _storyboard = require('storyboard');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var addVersionLine = function addVersionLine(_ref) {
  var changelogPath = _ref.changelogPath,
      version = _ref.version,
      _date = _ref._date;

  var contents = void 0;
  try {
    contents = _fs2.default.readFileSync(changelogPath, 'utf8');
  } catch (err) {
    _storyboard.mainStory.warn('Could not find changelog (' + _storyboard.chalk.cyan.bold(changelogPath) + '). Skipped update');
    return;
  }

  var date = _date || new Date();
  var line = '## ' + version + ' (' + date.getFullYear() + '-' + (date.getMonth() + 1) + '-' + date.getDate() + ')';
  var finalContents = line + '\n\n' + contents;
  try {
    _fs2.default.writeFileSync(changelogPath, finalContents, 'utf8');
  } catch (err) {
    throw new Error('Could not update changelog (' + changelogPath + ')');
  }
};

exports.addVersionLine = addVersionLine;